/*
  ptxt version 02, splash window
  GNU GPLv2, or at your option, any later version of that license.
  2022, torm
*/
#include <stdlib.h>
#include <gtk/gtk.h>

#define SBSIZE 1024

static gboolean timeout_quit(gpointer gdata);

static gboolean timeout_quit(gpointer gdata) {
    gtk_main_quit();
    return TRUE;
}

int main (int argc, char *argv[]) {
    gchar *ptfolder, *fxtext, buf[SBSIZE];
    gint dxx, dyy, sec, txx, tyy;
    if (argc < 6) {
        printf("Usage: ptxt AppFolder X-location Y-location \n");
        printf("                timeout-seconds text-X text-Y \n");
        return 1;
    }
    ptfolder = argv[1];
    dxx = atoi(argv[2]);
    dyy = atoi(argv[3]);
    sec = atoi(argv[4]);
    txx = atoi(argv[5]);
    tyy = atoi(argv[6]);
    if ( sec < 1) {
        printf("ptxt: unsupported timer value \n");
        return 1;
    }
    GtkWidget *window, *fixed, *label;
    GError *err;
    gtk_init (&argc, &argv);
    window = gtk_window_new(GTK_WINDOW_POPUP);
    snprintf(buf, SBSIZE, "/root/.ptxt/%s/gtkrc", ptfolder);
    gtk_rc_parse(buf);
    gtk_container_set_border_width(GTK_CONTAINER (window), 0);
    gtk_window_set_decorated(GTK_WINDOW (window), FALSE);
    gtk_window_set_skip_taskbar_hint(GTK_WINDOW (window), TRUE);
    gtk_window_set_skip_pager_hint(GTK_WINDOW (window), TRUE);
    g_signal_connect(G_OBJECT (window), "destroy", G_CALLBACK (gtk_main_quit), NULL);
    g_signal_connect(G_OBJECT (window), "focus-out-event", G_CALLBACK (gtk_main_quit), NULL);
    gtk_widget_set_events (window, GDK_BUTTON_RELEASE_MASK); /* window clicked, quit.. */
    g_signal_connect(G_OBJECT (window), "button_release_event", G_CALLBACK (gtk_main_quit), NULL);
    snprintf(buf, SBSIZE, "/root/.ptxt/%s/bg.png", ptfolder);
    GdkPixbuf *bgp = gdk_pixbuf_new_from_file(buf, 0);  /* no errors ? */
    gint bgx = gdk_pixbuf_get_width(bgp);
    gint bgy = gdk_pixbuf_get_height(bgp);
    GdkScreen *flscn = gdk_screen_get_default();
    gint xfres = gdk_screen_get_width(flscn);
    gint yfres = gdk_screen_get_height(flscn);  
    /* if bg.png does not fit on our display, ignore and use upper-left corner.. */
    if ((bgx > xfres) || (bgy > yfres)) {
        dyy = 0;
        dxx = 0;
    } else if (((dxx + bgx) > xfres) || ((dyy + bgy) > yfres)) {
    /* the location does not fit, ignore and try to center.. */
        dxx = xfres / 2 - bgx / 2;
        dyy = yfres / 2 - bgy / 2;
    }
    gtk_window_move(GTK_WINDOW(window), dxx, dyy);
    fixed = gtk_fixed_new ();
    gtk_widget_set_size_request(fixed, bgx, bgy);
    gtk_container_add(GTK_CONTAINER (window), fixed);
    GdkScreen *wscn = gtk_window_get_screen(GTK_WINDOW(window));
    GdkWindow *root = gdk_get_default_root_window();
    GdkColormap *colormap = gdk_screen_get_rgb_colormap(wscn);
    GdkPixbuf *shot = gdk_pixbuf_get_from_drawable(NULL, root, colormap, dxx, dyy, 0, 0, bgx, bgy);
    GtkWidget *ima = gtk_image_new_from_pixbuf(shot);
    gtk_fixed_put(GTK_FIXED(fixed), ima, 0, 0);
    GtkWidget *imb = gtk_image_new_from_pixbuf(bgp);
    gtk_fixed_put(GTK_FIXED(fixed), imb, 0, 0);
    snprintf(buf, SBSIZE, "/root/.ptxt/%s/text", ptfolder);
    g_file_get_contents(buf, &fxtext, NULL, &err);
    label = gtk_label_new(fxtext);
    gtk_widget_set_name(label, "themetext");
    gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
    gtk_fixed_put(GTK_FIXED(fixed), label, txx, tyy);
    gtk_widget_show(fixed);
    gtk_widget_show(ima);
    gtk_widget_show(imb);
    gtk_widget_show(label);
    gtk_widget_show(window);
    g_timeout_add_seconds(sec, timeout_quit, NULL);
    gtk_main ();
    return 0;
}

